from .ftdi import Ftdi as Ftdi, FtdiError as FtdiError
from .misc import classproperty as classproperty, to_bool as to_bool, to_int as to_int
from _typeshed import Incomplete
from typing import BinaryIO, List, NamedTuple, Optional, Set, TextIO, Union
from usb.core import Device as UsbDevice

class FtdiEepromError(FtdiError): ...
class Hex2Int(int): ...
class Hex4Int(int): ...

class FtdiEeprom:
    class _PROPS(NamedTuple):
        size: Incomplete
        user: Incomplete
        dynoff: Incomplete
        chipoff: Incomplete
    CBUS: Incomplete
    CBUSH: Incomplete
    CBUSX: Incomplete
    UART_BITS: Incomplete
    CHANNEL: Incomplete
    DRIVE: Incomplete
    CFG1: Incomplete
    VAR_STRINGS: Incomplete
    log: Incomplete
    def __init__(self) -> None: ...
    def __getattr__(self, name): ...
    def eeprom_sizes(cls) -> List[int]: ...
    def open(
        self,
        device: Union[str, UsbDevice],
        ignore: bool = ...,
        size: Optional[int] = ...,
        model: Optional[str] = ...,
    ) -> None: ...
    def close(self) -> None: ...
    def connect(self, ftdi: Ftdi, ignore: bool = ...) -> None: ...
    @property
    def device_version(self) -> int: ...
    @property
    def size(self) -> int: ...
    @property
    def default_size(self) -> int: ...
    @property
    def storage_size(self) -> int: ...
    @property
    def data(self) -> bytes: ...
    @property
    def properties(self) -> Set[str]: ...
    @property
    def is_empty(self) -> bool: ...
    @property
    def cbus_pins(self) -> List[int]: ...
    @property
    def cbus_mask(self) -> int: ...
    @property
    def has_mirroring(self) -> bool: ...
    @property
    def mirror_sector(self) -> int: ...
    @property
    def is_mirroring_enabled(self) -> bool: ...
    def enable_mirroring(self, enable: bool) -> None: ...
    def save_config(self, file: TextIO) -> None: ...
    def load_config(self, file: TextIO, section: Optional[str] = ...) -> None: ...
    def set_serial_number(self, serial: str) -> None: ...
    def set_manufacturer_name(self, manufacturer: str) -> None: ...
    def set_product_name(self, product: str) -> None: ...
    def set_property(
        self, name: str, value: Union[str, int, bool], out: Optional[TextIO] = ...
    ) -> None: ...
    def erase(self, erase_byte: Optional[int] = ...) -> None: ...
    def initialize(self) -> None: ...
    def sync(self) -> None: ...
    def dump_config(self, file: Optional[BinaryIO] = ...) -> None: ...
    def commit(self, dry_run: bool = ..., no_crc: bool = ...) -> bool: ...
    def reset_device(self) -> None: ...
